'use strict';

const{omitBy}=require("lodash");

const{TestOpenApiError}=require("../errors");
const{getPath}=require("../utils");
const{parseInput}=require("../serialize");

const{validateConfig}=require("./validate");
const DEFAULT_CONFIG=require("./defaults");


const loadConfig=function({config}){
validateConfig({config});

const configA=parseInput(config,throwParseError);


const configB=omitBy(configA,value=>value===undefined);
const configC={...DEFAULT_CONFIG,...configB};

return configC;
};



const throwParseError=function({message,value,path}){
const property=getPath(["config",...path]);
throw new TestOpenApiError(`Configuration ${message}`,{value,property});
};

module.exports={
loadConfig};
//# sourceMappingURL=main.js.map