'use strict';


const getTitle=function({rawRequest,rawResponse}){
const url=getUrl({rawRequest});
const status=getStatus({rawResponse});
return[url,status].filter(part=>part!==undefined).join(" ");
};

const getUrl=function({rawRequest:{method,url}}){

if(url===undefined){
return;
}

const urlA=url.replace(QUERY_REGEXP,"");

return`${method.toUpperCase()} ${urlA}`;
};


const QUERY_REGEXP=/\?[\0-\t\x0B\f\x0E-\u2027\u202A-\u{10FFFF}]*/u;

const getStatus=function({rawResponse:{status}={}}){

if(status===undefined){
return;
}

return`(${status})`;
};

module.exports={
getTitle};
//# sourceMappingURL=title.js.map