'use strict';

const{mapValues}=require("lodash");

const{parseFlat}=require("../../../utils");
const{findBodyHandler}=require("../body");


const parse=function({
call,
call:{rawResponse:{status,body,...headers}={}}={}})
{
if(call===undefined){
return;
}

const headersA=parseHeaders({headers});
const bodyA=parseBody({body,headers:headersA});

const response={status,...headersA,body:bodyA};
return{call:{...call,response}};
};


const parseHeaders=function({headers}){
return mapValues(headers,parseHeader);
};

const parseHeader=function(header){
const headerA=header.trim();


const headerB=parseFlat(headerA);
return headerB;
};


const parseBody=function({body,headers}){
const bodyA=trimBody({body});

if(bodyA===undefined){
return bodyA;
}


const mime=headers["headers.content-type"];

const{parse:parseFunc}=findBodyHandler({mime});


if(parseFunc===undefined){
return bodyA;
}

return parseFunc(bodyA);
};

const trimBody=function({body}){
const bodyA=body.trim();


if(bodyA===""){
return;
}

return bodyA;
};

module.exports={
parse};
//# sourceMappingURL=parse.js.map