'use strict';

const{addErrorHandler,TestOpenApiError}=require("../../../../errors");


const getRawResponse=async function({
rawResponse,
rawResponse:{status},
rawRequest})
{
const headers=getHeaders({rawResponse});
const body=await eGetBody({rawResponse,rawRequest});

return{status,...headers,body};
};








const getHeaders=function({rawResponse:{headers}}){
const headersA=[...headers.entries()];
const headersB=headersA.map(([name,value])=>({
[`headers.${name}`]:value}));

const headersC=Object.assign({},...headersB);
return headersC;
};


const getBody=function({rawResponse}){
return rawResponse.text();
};

const getBodyHandler=function(
{message,type},
{rawRequest:{timeout}})
{
const property="task.call.response.body";

if(type==="body-timeout"){
throw new TestOpenApiError(
`Parsing the response body took more than ${timeout} milliseconds`,
{property});

}

throw new TestOpenApiError(`Could not read response body: ${message}`,{
property});

};

const eGetBody=addErrorHandler(getBody,getBodyHandler);

module.exports={
getRawResponse};
//# sourceMappingURL=response.js.map