'use strict';

const{isObject}=require("../../../../utils");



const normalizeContentType=function({
call,
call:{body},
call:{"headers.content-type":contentTypeParam,...noBodyCall}})
{

if(body===undefined){
return noBodyCall;
}


if(contentTypeParam===undefined){
const contentType=getDefaultContentType({body});
return{...call,"headers.content-type":contentType};
}

return call;
};


const getDefaultContentType=function({body}){
if(isObject(body)||Array.isArray(body)){
return DEFAULT_OBJ_MIME;
}

return DEFAULT_NON_OBJ_MIME;
};




const DEFAULT_OBJ_MIME="application/json";
const DEFAULT_NON_OBJ_MIME="application/octet-stream";

module.exports={
normalizeContentType};
//# sourceMappingURL=content_type.js.map