'use strict';

const{parse,tokensToFunction}=require("path-to-regexp");

const{removePrefixes,getPath}=require("../../../../utils");
const{addErrorHandler,TestOpenApiError}=require("../../../../errors");






const addUrlParams=function({url,rawRequest}){
const urlParams=removePrefixes(rawRequest,"url");

const tokens=parseUrl({url});

validateRequiredParams({tokens,urlParams});

const urlA=serializeUrl({tokens,urlParams});
return urlA;
};


const parseUrl=function({url}){
const tokens=parse(url);
const tokensA=tokens.map(handlePort);
return tokensA;
};




const handlePort=function(token){
if(typeof token==="string"){
return token;
}

if(isPort(token)){
return`${token.delimiter}:${token.name}`;
}

return token;
};

const isPort=function({name,optional,repeat}){
return!optional&&!repeat&&PORT_REGEXP.test(name);
};

const PORT_REGEXP=/^[0-9]+$/u;



const validateRequiredParams=function({tokens,urlParams}){
tokens.forEach(token=>validateRequiredParam({token,urlParams}));
};

const validateRequiredParam=function({token,urlParams}){
if(!isRequiredParam(token)){
return;
}

const{name}=token;

if(urlParams[name]!==undefined&&urlParams[name]!==""){
return;
}

throwError("must not be empty",{name});
};

const isRequiredParam=function(token){
return typeof token!=="string"&&!token.optional;
};


const serializeUrl=function({tokens,urlParams}){



return tokens.map(token=>eSerializeToken({token,urlParams})).join("");
};

const serializeToken=function({token,urlParams}){

return tokensToFunction([token])(urlParams);
};

const serializeTokenHandler=function({message},{token:{name}}){
throwError(`is invalid: ${message}`,{name});
};

const eSerializeToken=addErrorHandler(serializeToken,serializeTokenHandler);

const throwError=function(message,{name}){
const property=getPath(["task","call",`url.${name}`]);
throw new TestOpenApiError(`The URL parameter '${name}' ${message}`,{
property});

};

module.exports={
addUrlParams};
//# sourceMappingURL=params.js.map