'use strict';require("core-js/modules/es6.array.sort");

const{omit}=require("lodash");

const{TestOpenApiError,addErrorHandler}=require("../../errors");
const{testRegExp}=require("../../utils");
const{merge:mergeWithTemplates}=require("../../template");






const load=function(tasks,{config:{merge:mergeConfig}}){
const{mergeTasks,nonMergeTasks}=splitTasks({tasks});
const tasksA=nonMergeTasks.map((task)=>
mergeTask({task,mergeTasks,mergeConfig}));

return tasksA;
};

const splitTasks=function({tasks}){
const mergeTasks=tasks.filter(isMergeTask);
const nonMergeTasks=tasks.filter(task=>!isMergeTask(task));
return{mergeTasks,nonMergeTasks};
};

const isMergeTask=function({merge}){
return merge!==undefined;
};

const mergeTask=function({task,mergeTasks,mergeConfig={}}){
const mergeTasksA=findMergeTasks({task,mergeTasks});

if(mergeTasksA.length===0){
return task;
}

return mergeWithTemplates(mergeConfig,...mergeTasksA,task);
};

const findMergeTasks=function({task:{key,scope},mergeTasks}){

return mergeTasks.
filter(({merge})=>eTestRegExp(merge,key)).
sort((taskA,taskB)=>compareMergeTasks({taskA,taskB,scope})).
map(task=>omit(task,NOT_MERGED_ATTRIBUTES));
};

const testRegExpHandler=function({message},merge){
throw new TestOpenApiError(`'task.merge' '${merge}' is invalid: ${message}`,{
value:merge,
property:"task.merge"});

};

const eTestRegExp=addErrorHandler(testRegExp,testRegExpHandler);









const compareMergeTasks=function({
taskA:{scope:scopeA},
taskB:{scope:scopeB},
scope})
{





if(scopeA===scopeB){
return 0;
}


if(scopeA===scope){
return 1;
}

if(scopeB===scope){
return-1;
}


if(scopeA===undefined){
return 1;
}

if(scopeB===undefined){
return-1;
}



if(scopeA<scopeB){
return-1;
}

return 1;
};

const NOT_MERGED_ATTRIBUTES=["key","scope","name","merge"];

module.exports={
load};
//# sourceMappingURL=load.js.map