'use strict';

const{TestOpenApiError,addErrorHandler}=require("../../errors");
const{testRegExp}=require("../../utils");




const load=function(tasks,{config:{only:configOnly}}){


const enabled=
configOnly!==undefined||tasks.some(({only})=>only!==undefined);

if(!enabled){
return;
}

const tasksA=tasks.map(task=>addExcluded({task,configOnly}));
return tasksA;
};

const addExcluded=function({task,task:{only,key},configOnly}){
if(isOnly({only,configOnly,key})){
return task;
}


return{...task,excluded:true};
};



const isOnly=function({only,configOnly,key}){
return(
only!==undefined||
configOnly!==undefined&&eTestRegExp(configOnly,key));

};

const testRegExpHandler=function({message},configOnly){
throw new TestOpenApiError(
`'config.only' '${configOnly}' is invalid: ${message}`,
{value:configOnly,property:"config.only"});

};

const eTestRegExp=addErrorHandler(testRegExp,testRegExpHandler);

module.exports={
load};
//# sourceMappingURL=load.js.map