'use strict';

const{isSimpleSchema}=require("../../../utils");


const addCoreReportProps=function({reportProps,task}){
const coreReportProps=getCoreReportProps(task);

return[coreReportProps,...reportProps];
};


const getCoreReportProps=function({
error:{
expected,
value,
message,
property,
schema,
module:moduleProp}=
{}})
{
const values=getValues({expected,value});
const schemaA=getJsonSchema({schema});
const propertyA=getProperty({property});
const modulePropA=getModule({moduleProp});

return{
message,
...values,
property:propertyA,
"JSON schema":schemaA,
...modulePropA};

};

const getValues=function({expected,value}){
if(expected===undefined){
return{value};
}

return{"actual value":value,"expected value":expected};
};

const getJsonSchema=function({schema}){


if(isSimpleSchema(schema)){
return;
}

return schema;
};

const getProperty=function({property}){
if(property===undefined){
return;
}

return property.replace(PROPERTY_REGEXP,"");
};

const PROPERTY_REGEXP=/^task\./u;


const getModule=function({moduleProp}){
if(moduleProp===undefined){
return;
}

const[type,...name]=moduleProp.split("-");
const nameA=name.join("-");

return{[type]:nameA};
};

module.exports={
addCoreReportProps};
//# sourceMappingURL=core.js.map