'use strict';

const{omit,omitBy}=require("lodash");

const{isObject,merge}=require("../../../utils");

const{addCoreReportProps}=require("./core");


const getReportProps=function({task,context}){
const{titles,reportProps}=callReportFuncs({task,context});

const reportPropsA=addCoreReportProps({reportProps,task});

const reportPropsB=reportPropsA.map(removeEmptyProps);




const reportPropsC=merge(...reportPropsB);

return{titles,reportProps:reportPropsC};
};


const callReportFuncs=function({
task,
context,
context:{_plugins:plugins}})
{


const reportResult=plugins.map((plugin)=>
callReportFunc({plugin,context,task}));



const titles=reportResult.map(({title})=>title).filter(isDefinedTitle);
const reportProps=reportResult.map(props=>omit(props,"title"));

return{titles,reportProps};
};


const callReportFunc=function({plugin:{report,name},context,task}){
const taskValue=task[name];


if(report===undefined){
return{[name]:taskValue};
}

const reportValue=getReportValue({report,context,taskValue});


if(!isObject(reportValue)){
return{[name]:reportValue};
}

const{title,reportProps}=mergeReportValue({reportValue,taskValue});

if(hasNoReportProps({reportProps,taskValue})){
return{title};
}

return{title,[name]:reportProps};
};

const getReportValue=function({report,context,taskValue}){
const contextA=omit(context,OMITTED_CONTEXT_PROPS);
const reportValue=report(taskValue,contextA);
return reportValue;
};

const OMITTED_CONTEXT_PROPS=["options","silent"];

const mergeReportValue=function({
reportValue:{title,...reportProps},
taskValue})
{


const reportPropsA={...reportProps,...taskValue,...reportProps};


const reportPropsB=removeEmptyProps(reportPropsA);
return{title,reportProps:reportPropsB};
};

const hasNoReportProps=function({reportProps,taskValue}){
return Object.keys(reportProps).length===0&&taskValue===undefined;
};

const isDefinedTitle=function(title){
return title!==undefined&&title.trim()!=="";
};


const removeEmptyProps=function(object){
return omitBy(object,value=>value===undefined);
};

module.exports={
getReportProps};
//# sourceMappingURL=main.js.map