'use strict';

const cliTruncate=require("cli-truncate");

const{
red,
inverse,
indent,
FULL_LOWER_LINE,
FULL_UPPER_LINE,
LINE_SIZE,
HORIZONTAL_LINE}=
require("../../../utils");
const{MARKS,COLORS}=require("../constants");





const getHeader=function({task,task:{isNested},titles,resultType}){
const subKeys=getSubKeys({titles});

if(isNested){
return getNestedHeader({task,subKeys});
}

return getFullHeader({task,subKeys,resultType});
};


const getSubKeys=function({titles}){
const titlesA=titles.join("\n");
const subKey=getSubKey(titlesA);
return subKey;
};

const getSubKey=function(string){
const stringA=string.trim();

if(stringA===""){
return"";
}

return`\n\n${indent(stringA)}`;
};


const getNestedHeader=function({task:{key},subKeys}){
const content=`${indent(`Nested task: ${key}`)}${subKeys}`;

const contentA=fitContent({content});

const header=red(`${HORIZONTAL_LINE}\n${contentA}\n${HORIZONTAL_LINE}`);
return header;
};

const getFullHeader=function({task:{key},subKeys,resultType}){
const content=` ${MARKS[resultType]}  ${key}${subKeys}`;

const contentA=fitContent({content});

const header=`${FULL_LOWER_LINE}\n${inverse(contentA)}\n${FULL_UPPER_LINE}`;
const headerA=COLORS[resultType].bold(header);
return headerA;
};




const fitContent=function({content}){
return content.
split("\n").
map(fitLine).
join("\n");
};

const fitLine=function(string){
const stringA=cliTruncate(string,LINE_SIZE-1);
const stringB=stringA.padEnd(LINE_SIZE);
return stringB;
};

module.exports={
getHeader};
//# sourceMappingURL=header.js.map