'use strict';

const{getSummary,yellow}=require("../../../utils");
const{NAMES}=require("../constants");


const printSummary=function({tasks}){
const{skip,pass,fail}=getSummary({tasks});

const summary={skip,pass,fail};


const padLength=String(summary.total).length;

return Object.entries(summary).
filter(shouldPrint).
map(([name,count])=>printEntry({name,count,padLength})).
join("\n");
};


const shouldPrint=function([name,count]){
return["pass","fail"].includes(name)||name==="skip"&&count!==0;
};

const printEntry=function({name,count,padLength}){
const nameA=NAMES[name];
const countA=String(count).padStart(padLength);
return`${yellow.bold(nameA)}${countA}`;
};

module.exports={
printSummary};
//# sourceMappingURL=summary.js.map