'use strict';

const{mapValues,mapKeys}=require("lodash");
const{underscored}=require("underscore.string");

const{removeColors}=require("../../../utils");


const getErrorProps=function({ok,reportProps}){
if(ok){
return;
}

const reportPropsA=normalizeReportProps({reportProps});


const{
message,
operator,
expected,
actual,
value,
schema,
property,
...rest}=
reportPropsA;

return{
message,
operator,
severity:"fail",
expected,
actual,
value,
schema,
property,
...rest};

};










const normalizeReportProps=function({reportProps}){
const reportPropsA=mapValues(reportProps,normalizeReportPropValue);
const reportPropsB=mapKeys(reportPropsA,normalizeReportPropKey);
return reportPropsB;
};

const normalizeReportPropValue=function(value){
return removeColors(value);
};

const normalizeReportPropKey=function(value,name){
const tapName=TAP_NAMES[name];

if(tapName!==undefined){
return tapName;
}

return underscored(name);
};


const TAP_NAMES={
message:"message",
plugin:"operator",
reporter:"operator",
value:"value",
"expected value":"expected",
"actual value":"actual",
"JSON schema":"schema",
property:"property"};


module.exports={
getErrorProps};
//# sourceMappingURL=error_props.js.map