'use strict';

const{dump:yamlDump,DEFAULT_FULL_SCHEMA}=require("js-yaml");
const{omitBy}=require("lodash");

const{indent}=require("../../../utils");


const getErrorProps=function({ok,error}){
if(ok||error===undefined){
return"";
}

const errorA=getError(error);

const errorProps=serializeErrorProps({error:errorA});
return errorProps;
};

const getError=function({message,name,stack,...error}){
const at=getAt({stack});

const errorA={message,operator:name,at,stack,...error};
const errorB=omitBy(errorA,value=>value===undefined);
return errorB;
};

const getAt=function({stack}){
if(stack===undefined){
return;
}

const[,at]=stack.split("\n");
return at.replace(AT_REGEXP,"");
};


const AT_REGEXP=/^[\0-\t\x0B\f\x0E-\u2027\u202A-\u{10FFFF}]*at /u;


const serializeErrorProps=function({error}){
const errorProps=yamlDump(error,YAML_OPTS);
const errorPropsA=indent(errorProps);
const errorPropsB=`\n  ---\n${errorPropsA}...`;
return errorPropsB;
};

const YAML_OPTS={
schema:DEFAULT_FULL_SCHEMA,
noRefs:true,

flowLevel:1};


module.exports={
getErrorProps};
//# sourceMappingURL=error_props.js.map