'use strict';

const{getDirective}=require("./directive");
const{checkArgument}=require("./check");


const plan=function({count}){
if(count===undefined){
return"";
}

checkArgument(count,"integer");

const planString=getPlanString({count});

return`${planString}\n\n`;
};

const getPlanString=function({count}){
const planString=getPlan({count});

const directiveString=getPlanDirective({count});

return`${planString}${directiveString}`;
};

const getPlan=function({count}){
if(count===0){

return"1..0";
}

return`1..${String(count)}`;
};


const getPlanDirective=function({count}){
if(count!==0){
return"";
}

const directive={skip:true};
const directiveString=getDirective({directive});
return directiveString;
};

module.exports={
plan,
getPlanString};
//# sourceMappingURL=plan.js.map