'use strict';

const{testRegExp}=require("../../utils");
const{TestOpenApiError,addErrorHandler}=require("../../errors");



const load=function(tasks,{config:{skip:configSkip}}){
const tasksA=tasks.map(task=>addSkipped({task,configSkip}));
return tasksA;
};

const addSkipped=function({task,task:{skip,key},configSkip}){
if(!isSkipped({skip,configSkip,key})){
return task;
}

return{...task,skipped:true};
};





const isSkipped=function({skip,configSkip,key}){
return(
skip!==undefined||
configSkip!==undefined&&eTestRegExp(configSkip,key));

};

const testRegExpHandler=function({message},configSkip){
throw new TestOpenApiError(
`'config.skip' '${configSkip}' is invalid: ${message}`,
{value:configSkip,property:"config.skip"});

};

const eTestRegExp=addErrorHandler(testRegExp,testRegExpHandler);

module.exports={
load};
//# sourceMappingURL=load.js.map