'use strict';

const{mapValues,omit,omitBy}=require("lodash");






const removeOptionals=function({params,call}){
const paramsA=removeTopLevel({params,call});
const paramsB=removeNested({params:paramsA,call});
return paramsB;
};


const removeTopLevel=function({params,call}){
const paramsA=omitBy(params,(param,key)=>
isSkippedOptional({param,key,call}));

const paramsB=mapValues(paramsA,removeOptionalProp);
return paramsB;
};

const isSkippedOptional=function({param:{optional},key,call}){
return optional&&call[key]===undefined;
};


const removeOptionalProp=function(param){
return omit(param,"optional");
};


const removeNested=function({params,call}){
return mapValues(params,(schema,key)=>
removeNonRequired({schema,definedProps:call[key]}));

};


const removeNonRequired=function({
schema:{properties,required=[],...schema},
definedProps={}})
{
if(properties===undefined){
return schema;
}

const propertiesA=omitBy(
properties,
(property,name)=>
!required.includes(name)&&definedProps[name]===undefined);


const propertiesB=mapValues(propertiesA,(property,name)=>
removeNonRequired({schema:property,definedProps:definedProps[name]}));


return{...schema,properties:propertiesB};
};

module.exports={
removeOptionals};
//# sourceMappingURL=optional.js.map