'use strict';

const SwaggerParser=require("swagger-parser");

const{addErrorHandler,TestOpenApiError}=require("../../../errors");




const loadOpenApiSpec=function({spec}){
return SwaggerParser.validate(spec);
};

const loadSpecHandler=function({message,details}){
if(!Array.isArray(details)){
fetchSpecHandler({message});
}

invalidSpecHandler({details});
};


const fetchSpecHandler=function({message}){
throw new TestOpenApiError(
`OpenAPI specification could not be loaded: ${message}`);

};


const invalidSpecHandler=function({details,details:[{path}]}){
const message=details.map(getErrorMessage).join(`\n${INDENT}`);
throw new TestOpenApiError(
`OpenAPI specification is invalid at ${path.join(
".")
}:\n${INDENT}${message}`);

};

const INDENT_LENGTH=4;
const INDENT=" ".repeat(INDENT_LENGTH);

const getErrorMessage=function({path,message}){
return`At '${path.join(".")}': ${message}`;
};

const eLoadOpenApiSpec=addErrorHandler(loadOpenApiSpec,loadSpecHandler);

module.exports={
loadOpenApiSpec:eLoadOpenApiSpec};
//# sourceMappingURL=load.js.map