'use strict';

const{groupBy}=require("lodash");

const{loadOpenApiSpec}=require("./load");
const{normalizeSpec}=require("./normalize");




const start=async function(startData,{_allTasks:allTasks}){
const tasksGroups=groupTasks({allTasks});




const specStartData=await Promise.all(tasksGroups.map(loadSpec));
const specStartDataA=Object.assign({},...specStartData);
return{spec:specStartDataA};
};



const groupTasks=function({allTasks}){
const tasksGroups=groupBy(allTasks,stringifyDefinition);
const tasksGroupsA=Object.values(tasksGroups);
return tasksGroupsA;
};


const loadSpec=async function(tasks){

const definition=getDefinition(tasks[0]);

if(definition===undefined){
return;
}

const spec=await loadOpenApiSpec({spec:definition});

const definitionA=normalizeSpec({spec});

const specStartData=tasks.map(({key})=>({[key]:definitionA}));
const specStartDataA=Object.assign({},...specStartData);
return specStartDataA;
};

const stringifyDefinition=function(task){
const definition=getDefinition(task);
return JSON.stringify(definition);
};

const getDefinition=function({spec:{definition}={}}){
return definition;
};

module.exports={
start};
//# sourceMappingURL=main.js.map