'use strict';




const filterFormDataMimes=function({mimes,params}){
if(hasFormDataParams({params})){
return keepFormDataMimes({mimes});
}

return removeFormDataMimes({mimes});
};

const hasFormDataParams=function({params}){
return Object.keys(params).some(isFormData);
};

const keepFormDataMimes=function({mimes}){
const mimesA=mimes.filter(isFormDataMime);




if(mimesA.length===0){
return FORM_DATA_MIMES;
}

return mimesA;
};

const removeFormDataMimes=function({mimes}){
const mimesA=mimes.filter(mime=>!isFormDataMime(mime));




if(mimesA.length===0){
return mimes;
}

return mimesA;
};

const isFormDataMime=function(mime){
return FORM_DATA_MIMES.some(formDataMime=>mime.startsWith(formDataMime));
};

const FORM_DATA_MIMES=[
"application/x-www-form-urlencoded",
"multipart/form-data"];


const isFormData=function(key){
return FORM_DATA_REGEXP.test(key);
};

const removeFormDataPrefix=function(key){
return key.replace(FORM_DATA_REGEXP,"");
};

const FORM_DATA_REGEXP=/^formData\./u;

module.exports={
filterFormDataMimes,
isFormData,
removeFormDataPrefix};
//# sourceMappingURL=form_data.js.map