'use strict';

const{omitBy,pickBy,mapKeys}=require("lodash");

const{isFormData,removeFormDataPrefix}=require("../form_data");





const normalizeFormData=function({params}){
const formDataParams=pickBy(params,(value,key)=>isFormData(key));

if(Object.keys(formDataParams).length===0){
return params;
}

const paramsA=formDataToBody({formDataParams,params});
return paramsA;
};

const formDataToBody=function({formDataParams,params}){
const body=getBody({formDataParams});
const paramsA=omitBy(params,(value,key)=>isFormData(key));
return{...paramsA,body};
};

const getBody=function({formDataParams}){
const properties=mapKeys(formDataParams,(value,key)=>
removeFormDataPrefix(key));

const required=getRequired({properties});




return{type:"object",properties,required};
};

const getRequired=function({properties}){
return Object.entries(properties).
filter(([,{optional}])=>!optional).
map(([key])=>key);
};

module.exports={
normalizeFormData};
//# sourceMappingURL=form_data.js.map