'use strict';

const{pick,omit}=require("lodash");

const{promiseThen}=require("../../../utils");
const{addErrorHandler}=require("../../../errors");
const{evalTemplate}=require("../../../template");

const{getPluginsVars}=require("./plugin");
const{templateHandler}=require("./error");

















const run=function(task,context){
const{vars,pluginsVarsMap}=getVars({task,context});

const noEvalProps=pick(task,NO_EVAL_PROPS);
const taskA=omit(task,NO_EVAL_PROPS);

const taskB=eEvalTaskTemplate({task:taskA,vars,pluginsVarsMap});

return promiseThen(taskB,taskC=>returnTask({task:taskC,noEvalProps}));
};


const NO_EVAL_PROPS=["originalTask","key","variables","template"];



const getVars=function({task:{template:taskTemplates},context}){
const{pluginsVars,pluginsVarsMap}=getPluginsVars({context});

const vars={...pluginsVars,...taskTemplates};

return{vars,pluginsVarsMap};
};

const evalTaskTemplate=function({task,vars}){
return evalTemplate(task,vars);
};

const eEvalTaskTemplate=addErrorHandler(evalTaskTemplate,templateHandler);



const returnTask=function({task,noEvalProps}){
const taskA={...task,...noEvalProps};


const taskB=omit(taskA,"originalTask");
return{...taskB,originalTask:taskB};
};

module.exports={
run};
//# sourceMappingURL=main.js.map