'use strict';

const jsonSchemaFaker=require("json-schema-faker");

const formatRegExps=require("ajv/lib/compile/formats");




const addCustomFormats=function(){
Object.entries(CUSTOM_FORMATS).forEach(addCustomFormat);
};

const addCustomFormat=function([name,regexp]){
jsonSchemaFaker.format(name,()=>jsonSchemaFaker.random.randexp(regexp));
};


const UUID_REGEXP=/^[0-9a-f]{8}\x2D(?:[0-9a-f]{4}\x2D){3}[0-9a-f]{12}$/u;

const CUSTOM_FORMATS={

"uri-template":formatRegExps.full["uri-template"],
"json-pointer":formatRegExps.full["json-pointer"],


date:formatRegExps.fast.date,
time:formatRegExps.fast.time,
"relative-json-pointer":formatRegExps.full["relative-json-pointer"],


url:formatRegExps.full.url,
"json-pointer-uri-fragment":formatRegExps.full["json-pointer-uri-fragment"],
uuid:UUID_REGEXP};


module.exports={
addCustomFormats};
//# sourceMappingURL=format.js.map