

'use strict';

const{
isSimpleSchema,
getSimpleSchemaConstant,
getWordsList}=
require("../utils");


















class PropsError extends Error{
constructor(message,properties={}){
super(message);

this.name="PropsError";

Object.keys(properties).forEach(validateProperty);

const expected=getExpected({properties});


Object.assign(this,{...properties,...expected});
}}



const validateProperty=function(property){
if(VALID_PROPERTIES.includes(property)){
return;
}

const validProperties=getWordsList(VALID_PROPERTIES,{op:"and"});
throw new BugError(
`Error property '${property}' is invalid. The only valid error properties are: ${validProperties}`,
{value:property,expected:VALID_PROPERTIES});

};

const USER_VALID_PROPERTIES=["property","value","expected","schema"];
const CORE_VALID_PROPERTIES=[
"config",
"plugins",
"module",
"bug",
"task",
"tasks",
"errors",
"nested"];

const VALID_PROPERTIES=[...USER_VALID_PROPERTIES,...CORE_VALID_PROPERTIES];


const getExpected=function({properties:{schema,expected}}){
if(expected!==undefined){
return{expected};
}

if(!isSimpleSchema(schema)){
return;
}

const expectedA=getSimpleSchemaConstant(schema);
return{expected:expectedA};
};


class TestOpenApiError extends PropsError{
constructor(...args){
super(...args);

this.name="TestOpenApiError";
}}






class BugError extends PropsError{
constructor(...args){
super(...args);

this.name="BugError";
}}


module.exports={
TestOpenApiError,
BugError};
//# sourceMappingURL=error.js.map