'use strict';

const keepFuncProps=require("keep-func-props");




const addErrorHandler=function(func,errorHandler=()=>{}){
return errorHandledFunc.bind(null,func,errorHandler);
};

const kAddErrorHandler=keepFuncProps(addErrorHandler);

const errorHandledFunc=function(func,errorHandler,...args){
try{
const retVal=func(...args);



return retVal&&typeof retVal.then==="function"?
retVal.catch(error=>handleError({func,errorHandler,error,args})):
retVal;
}catch(error){
return handleError({func,errorHandler,error,args});
}
};

const handleError=function({func,errorHandler,error,args}){
const errorA=normalizeError(func,error);
return errorHandler(errorA,...args);
};


const normalizeError=function(func,error){
if(error instanceof Error){
return error;
}

const errorA=new Error(error);

addStack(errorA);

return errorA;
};


const addStack=function(error){
const obj={};
Error.captureStackTrace(obj,errorHandledFunc);
const{stack}=obj;


error.stack=stack;
};

module.exports={
addErrorHandler:kAddErrorHandler};
//# sourceMappingURL=handler.js.map