'use strict';

const{uniq,difference}=require("lodash");

const{getModule}=require("../modules");

const PLUGIN_SCHEMA=require("./plugin_schema");
const{validateJsonSchemas}=require("./validate");
const{verifyConfig}=require("./verify");



const loadPlugins=function({config,config:{plugins}}){
const pluginsA=normalizePlugins({plugins});

const pluginsB=pluginsA.map(name=>loadPlugin({name,config}));
return pluginsB;
};

const normalizePlugins=function({plugins}){

const pluginsA=difference(plugins,CORE_PLUGINS);

const pluginsB=uniq(pluginsA);

const pluginsC=[...CORE_PLUGINS,...DEFAULT_PLUGINS,...pluginsB];
return pluginsC;
};


const CORE_PLUGINS=[
"merge",
"only",
"skip",
"repeat",
"variables",
"template",
"verify",
"report"];



const DEFAULT_PLUGINS=["spec","call","validate"];

const loadPlugin=function({name,config}){
const plugin=getModule(name,MODULE_OPTS);

validateJsonSchemas({plugin});

verifyConfig({plugin,config});

return plugin;
};

const MODULE_OPTS={
title:"plugin",
modulePrefix:"test-openapi-plugin-",
corePath:"../core/",
schema:PLUGIN_SCHEMA};










































































































module.exports={
loadPlugins};
//# sourceMappingURL=load.js.map