'use strict';

const{omitBy}=require("lodash");

const{isObject}=require("../../utils");

const{getAddedProps}=require("./added");







const getTaskReturn=function({
task,
task:{key,scope,name,skipped,error,originalTask},
plugins})
{
const pluginReturns=getPluginReturns({plugins,task});




const taskA={
key,
scope,
name,
skipped,
error,
...pluginReturns,
originalTask};



const taskB=omitBy(taskA,value=>value===undefined);

return taskB;
};


const getPluginReturns=function({plugins,task}){
const pluginReturns=plugins.map(plugin=>getPluginReturn({task,plugin}));
const pluginReturnsA=Object.assign({},...pluginReturns);
return pluginReturnsA;
};

const getPluginReturn=function({task,plugin,plugin:{name}}){
const returnValue=getReturnValue({task,plugin});

if(returnValue===undefined){
return;
}

return{[name]:returnValue};
};

const getReturnValue=function({
task,
task:{originalTask},
plugin,
plugin:{name}})
{
const addedProps=getAddedProps({task,plugin});

const originalValue=originalTask[name];

if(addedProps===undefined){
return originalValue;
}

if(!isObject(addedProps)){
return addedProps;
}

return{...addedProps,...originalValue};
};

module.exports={
getTaskReturn};
//# sourceMappingURL=main.js.map