
'use strict';

const{addErrorHandler,TestOpenApiError}=require("../errors");
const{runHandlers,getTaskReturn}=require("../plugins");


const runTask=async function({task,context,plugins,nestedPath}){
const taskA=await eRunAll({task,context,plugins,nestedPath});

const taskB=getTaskReturn({task:taskA,plugins});
return taskB;
};

const runAll=function({
task,
task:{skipped},
context,
plugins,
nestedPath})
{





if(skipped&&nestedPath===undefined){
return task;
}

const contextA=getContext({context,plugins,nestedPath});

return runHandlers({
type:"run",
plugins,
input:task,
context:contextA,
errorHandler:runPluginHandler,
stopFunc});

};



const runAllHandler=function(error){
const{task}=error;


delete error.task;

task.error=error;

return task;
};

const eRunAll=addErrorHandler(runAll,runAllHandler);

const getContext=function({context,plugins,nestedPath}){
const recursiveRunTaskA=recursiveRunTask.bind(null,{
context,
plugins,
nestedPath});


const contextA={
...context,
_runTask:recursiveRunTaskA,
_nestedPath:nestedPath};

return contextA;
};




const recursiveRunTask=async function(
{context,plugins,nestedPath},
{task,task:{key},self,getError})
{
checkRecursion({nestedPath,key,self});

const nestedPathA=appendNestedPath({nestedPath,key,self});

const taskA=await runTask({
task,
context,
plugins,
nestedPath:nestedPathA});


const{error}=taskA;

if(error===undefined){
return taskA;
}

throwRecursiveError({task:taskA,error,getError});
};






const checkRecursion=function({nestedPath=[],key,self}){
if(self||!nestedPath.includes(key)){
return;
}

const cycle=[...nestedPath,key].join(`\n ${RIGHT_ARROW} `);
throw new TestOpenApiError(`Infinite task recursion:\n   ${cycle}`);
};

const RIGHT_ARROW="\u21AA";

const appendNestedPath=function({nestedPath=[],key,self}){



if(self){
return nestedPath;
}

return[...nestedPath,key];
};





const throwRecursiveError=function({task,error,getError}){
if(getError===undefined){

error.task=task;
throw error;
}



const topError=getError();


topError.nested={...task,error};

throw topError;
};






const runPluginHandler=function(error,task){

if(error.task===undefined){

error.task=task;
}

throw error;
};





const stopFunc=function({done}){
return done;
};

module.exports={
runTask};
//# sourceMappingURL=run.js.map