'use strict';

const{capitalize}=require("underscore.string");

const{getPath}=require("../utils");
const{convertPlainObject,BugError}=require("../errors");



const addSerializeFail=function({task,error,plugins}){
if(error===undefined){
return task;
}

const errorA=getSerializeFail({error,plugins});
const errorB=convertPlainObject(errorA);

return{...task,error:errorB};
};

const getSerializeFail=function({
error:{message,value,path},
plugins})
{
const messageA=capitalize(message);

const valueA=String(value);
const property=getPath(["task",...path]);
const moduleProp=guessModule({path,plugins});

const error=new BugError(messageA,{
value:valueA,
property,
...moduleProp});

return error;
};



const guessModule=function({path:[name],plugins}){
const plugin=plugins.find(({name:nameA})=>nameA===name);

if(plugin===undefined){
return;
}

return{module:`plugin-${name}`};
};

module.exports={
addSerializeFail};
//# sourceMappingURL=fail.js.map