'use strict';

const{basename}=require("path");

const{omit}=require("lodash");

const{TestOpenApiError}=require("../errors");




const addScopes=function({tasks,path}){
const scope=getScope(path);
const tasksA=tasks.map(task=>({...task,scope}));
return tasksA;
};

const getScope=function(path){
const filename=basename(path);
const scope=filename.replace(/\.[\0-\t\x0B\f\x0E-\u2027\u202A-\u{10FFFF}]*/u,"");
return scope;
};






const addKey=function({scope,name,...task}){

const taskA=omit(task,"key");

if(scope===undefined){
return{key:name,name,...taskA};
}

const key=`${scope}/${name}`;

return{key,scope,name,...task};
};



const validateScopes=function({paths}){
const scopes=paths.map(getScope);
scopes.forEach((scope,index)=>
validateScope({scope,index,scopes,paths}));

};

const validateScope=function({scope,index,scopes,paths}){
const scopesA=scopes.slice(index+1);
const duplicateScopeIndex=scopesA.indexOf(scope);

if(duplicateScopeIndex===-1){
return;
}

const path=paths[index];
const duplicatePath=paths[duplicateScopeIndex+index+1];
throw new TestOpenApiError(
`Each task file name must be unique, but the two following files are not: '${path}' and '${duplicatePath}'`);

};

module.exports={
addScopes,
getScope,
addKey,
validateScopes};
//# sourceMappingURL=scope.js.map