'use strict';

const{omit}=require("lodash");

const{getPath}=require("../utils");


const templateHandler=function(error,{template,data,path}){
appendMessage({error,template});

setErrorProps({error,data,path});

throw error;
};

const appendMessage=function({error,template:{name}}){
const message=getMessage({error});

error.message=`${TEMPLATE_ERROR_MESSAGE} '${name}': ${message}`;
};


const getMessage=function({error:{message}}){
if(!message.startsWith(TEMPLATE_ERROR_MESSAGE)){
return message;
}

return message.replace(TEMPLATE_ERROR_REGEXP,"");
};

const TEMPLATE_ERROR_REGEXP=/^[\0-9;-\u{10FFFF}]*: /u;
const TEMPLATE_ERROR_MESSAGE="Error when evaluating template";






const setErrorProps=function({error,data,path}){
const property=getPath(path);



const errorProps=omit(error,KEPT_ERROR_PROPS);

Object.keys(errorProps).forEach(errorProp=>delete error[errorProp]);
const value={template:data,...errorProps};


Object.assign(error,{property,value});
};


const KEPT_ERROR_PROPS=["name","nested"];

module.exports={
templateHandler};
//# sourceMappingURL=error.js.map