'use strict';

const{getPath}=require("./path");


const jsonPointerToPath=function(jsonPointer){
const parts=jsonPointerToParts(jsonPointer);

const path=getPath(parts);
return path;
};

const jsonPointerToParts=function(jsonPointer){
const jsonPointerA=decodeUriFragment({jsonPointer});

const jsonPointerB=jsonPointerA.replace(START_SLASH_REGEXP,"");

if(jsonPointerB===""){
return"";
}

const parts=jsonPointerB.
split("/").
map(unescapeJsonPointer).
map(numerizeIndex);
return parts;
};

const START_SLASH_REGEXP=/^\//u;


const decodeUriFragment=function({jsonPointer}){

if(!jsonPointer.startsWith("#")){
return jsonPointer;
}

const jsonPointerA=jsonPointer.replace(START_HASH_REGEXP,"");

const jsonPointerB=decodeURIComponent(jsonPointerA);
return jsonPointerB;
};

const START_HASH_REGEXP=/^#/u;


const unescapeJsonPointer=function(jsonPointer){
return jsonPointer.
replace(ESCAPED_TILDE_REGEXP,"~").
replace(ESCAPED_SLASH_REGEXP,"/");
};

const ESCAPED_TILDE_REGEXP=/~0/gu;
const ESCAPED_SLASH_REGEXP=/~1/gu;


const numerizeIndex=function(value){
const valueA=Number(value);

if(!Number.isInteger(valueA)){
return value;
}

return valueA;
};

module.exports={
jsonPointerToPath,
jsonPointerToParts};
//# sourceMappingURL=json_pointer.js.map