'use strict';

const{omitBy}=require("lodash");

const{TestOpenApiError,BugError}=require("../errors");
const{crawl,isObject}=require("../utils");

const{validateFromSchema}=require("./validate");





const checkSchema=function({bug=false,value,...opts}){
const valueA=removeUndefined({value});

const error=validateFromSchema({...opts,value:valueA});

if(error===undefined){
return;
}

const ErrorType=bug?BugError:TestOpenApiError;
const{message}=error;
const errorProps=getErrorProps({opts,error});

throw new ErrorType(message,errorProps);
};










const removeUndefined=function({value}){
return crawl(value,removeUndefinedProp);
};

const removeUndefinedProp=function(value){
if(!isObject(value)){
return value;
}

return omitBy(value,valueA=>valueA===undefined);
};

const getErrorProps=function({
opts:{schemaProp,props},
error:{value,schema,valuePath,schemaPath}})
{
const property=getProperty({schemaProp,valuePath,schemaPath});
return{value,schema,...property,...props};
};

const getProperty=function({schemaProp,valuePath,schemaPath}){
const property=schemaProp===undefined?valuePath:schemaPath;

if(property===""){
return;
}

return{property};
};

module.exports={
checkSchema};
//# sourceMappingURL=check.js.map