'use strict';


const JSON_SCHEMA_SCHEMA=require("ajv/lib/refs/json-schema-draft-04");
const{omit}=require("lodash");

const{checkSchema}=require("./check");


const checkIsSchema=function(opts){
const message=getSchemaMessage(opts);

checkSchema({schema:jsonSchemaSchema,message,...opts});
};

const getSchemaMessage=function({valueProp}){
const name=valueProp===undefined?"schema":`'${valueProp}'`;
return`${name} is not a valid JSON schema version 4`;
};

const getJsonSchemaSchema=function(){
return SCHEMA_FIXES.reduce((schema,fix)=>fix(schema),JSON_SCHEMA_SCHEMA);
};

const removeId=function(schema){
return omit(schema,["id","$schema"]);
};



const fixMultipleOf=function(schema){
const multipleOf={type:"number",exclusiveMinimum:0};

return{
...schema,
properties:{...schema.properties,multipleOf}};

};


const fixFormat=function(schema){
const format={type:"string"};
return{...schema,properties:{...schema.properties,format}};
};



const fixCustomProperties=function(schema){
return{
...schema,
patternProperties:{"^x-*":{}},
additionalProperties:false};

};

const SCHEMA_FIXES=[removeId,fixMultipleOf,fixFormat,fixCustomProperties];

const jsonSchemaSchema=getJsonSchemaSchema();

module.exports={
checkIsSchema};
//# sourceMappingURL=meta.js.map